//+------------------------------------------------------------------+
//| Stretch.mq4
//| Copyright http://www.pointzero-trading.com
//+------------------------------------------------------------------+
#property copyright "Copyright  Pointzero-trading.com"
#property link      "http://www.pointzero-trading.com"
#property indicator_separate_window
#property indicator_buffers 2
#property indicator_color1 MediumSeaGreen
#property indicator_color2 Red
#property indicator_width1 2
#property indicator_width2 1
#property indicator_style2 STYLE_DOT

#include <Stretch.mqh>
#define MaMethod 2

//--External variables
input int StPeriod   = 10;
input int AvPeriod   = 12;

//-- Buffers
double FextMapBuffer1[];
double FextMapBuffer2[];

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//|------------------------------------------------------------------|
int OnInit()
{   
   SetIndexStyle(0,DRAW_HISTOGRAM);
   SetIndexBuffer_(0, FextMapBuffer1);
   SetIndexStyle(1,DRAW_LINE);
   SetIndexBuffer_(1,FextMapBuffer2);    
   IndicatorShortName("Stretch ("+ StPeriod +","+ AvPeriod +")");
   Comment("Copyright  http://www.pointzero-trading.com");
   return(0);
}

//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
void OnDeinit(const int reason)
{
   //return(0);
}

//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int OnCalculate(const int rates_total,
                const int prev_calculated,
                const datetime& time[],
                const double& open[],
                const double& high[],
                const double& low[],
                const double& close[],
                const long& volume[],
                const long& real_volume[],
                const int& spread[])
{
   // Start, limit, etc..
   int start = 1;
   int limit;
   int counted_bars = prev_calculated;
   
   // nothing else to do?
   if(counted_bars < 0) 
       return(-1);

   // do not check repeated bars
   limit = Bars - 1 - counted_bars;
   
   // Iteration
   for(int pos = limit; pos >= start; pos--)
   {  
      // Stretch for today
      double sum = 0;
      FextMapBuffer1[pos] = EMPTY_VALUE;
      for(int i = 0; i < StPeriod; i++)
      {
         double oh = MathAbs(High[pos+i] - Open[pos+i]);
         double ol = MathAbs(Open[pos+i] - Low[pos+i]);
         if(ol < oh) sum += ol; else sum+= oh;
      }
      FextMapBuffer1[pos] = sum / StPeriod;
   }
   for(pos = limit; pos >= start; pos--) FextMapBuffer2[pos] = iMAOnArray(FextMapBuffer1, Bars, AvPeriod, 0, MaMethod, pos);
   return(rates_total);//   return(0);
}